﻿using BA.Core.CustomAttributes;
using BA.Core.DB;
using BA.Core.Enums;
using BA.Training.DB.Interfaces;
using BA.Training.Enums.Extensions;
using DevExpress.Data.Filtering;
using DevExpress.Xpo;
using DevExpress.Xpo.Metadata;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Reflection;

namespace BA.Training.DB
{
    [DesignTimeVisible(true)]
    [Description("Maschine für die Business App Entwickler Schulung")]
    public partial class OrmEngine : IOrmEngine
    {
        public OrmEngine() : base() { }
        public OrmEngine(Session session) : base(session) { }
        public override void AfterConstruction() { base.AfterConstruction(); }

        [Newtonsoft.Json.JsonIgnore]
        [DontShowFieldInDesigner]
        [RelationDefinitionTarget("67D7204E-EE21-4926-B2F7-A9E82A5B8552", EnumRelationTypeExtension.ResponsibleGuid, MinCount = 0, MaxCount = 1)]
        public OrmUserProfile RelatedResponsible
        {
            get
            {
                return GetSourcePrimary<OrmUserProfile>(EnumRelationTypeExtension.Responsible);
            }
        }

        [Newtonsoft.Json.JsonIgnore]
        [DontShowFieldInDesigner]
        [RelationDefinitionTarget("00016884-8F07-40A0-BB20-A15C623C197C", EnumRelationType.ParentGuid, EnumParentRelationSubtypesExtension.EnginePartGuid, MinCount = 0, MaxCount = 0)]
        public IQueryable<OrmEngine> RelatedMainEngines
        {
            get
            {
                return GetSources<OrmEngine>(EnumRelationType.Parent, EnumParentRelationSubtypesExtension.EnginePartGuid);
            }
        }

        [Newtonsoft.Json.JsonIgnore]
        [DontShowFieldInDesigner]
        [RelationDefinitionSource("00016884-8F07-40A0-BB20-A15C623C197C")]
        public IQueryable<OrmEngine> RelatedEngineParts
        {
            get
            {
                return GetTargets<OrmEngine>(EnumRelationType.Parent, EnumParentRelationSubtypesExtension.EnginePartGuid);
            }
        }
    }
}
