﻿using BA.Core.CustomAttributes;
using BA.Core.DB;
using BA.Training.CustomAttributes.Validations;
using BA.Training.DB;
using BA.Training.Enums;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;

namespace BA.Training.OrmEvents
{
    [BAOrmEvents(typeof(OrmEngine))]
    public class SetDefaultEngineType : BAOrmEventsBase
    {
        public override void OnCreated(OrmBABase orm)
        {
            OrmEngine engine = (OrmEngine)orm;
            engine.SetEnumValue(nameof(OrmEngine.Type), EnumEngineTypes.MechanicalPress);
        }

        public override void OnAfterOrmValidation(OrmBABase orm, ref bool baseValidationResult)
        {
            OrmEngine engine = (OrmEngine)orm;
            if (engine.Type == null)
            {
                engine.ValidationResults.Add(new ValidationResult("Der Typ der Maschine muss gesetzt sein.", new[] { nameof(OrmEngine.Type) }));
                baseValidationResult = false;
            }
        }
    }
}