declare module BA.Ui.Controls {
    class HTMLControlEvents {
        private static popUp;
        private static editorTarget;
        private static isFullscreen;
        /**
         * Fired when dialog for upload image or insert link is created (but before dialog is shown)
         * @param s Handle of html control
         * @param e event arguments
         */
        static DialogInitialzed(s: BAClientHtmlEditor, e: ASPxClientHtmlEditorDialogInitializedEventArgs): void;
        /**
         * Init mehthod of html control
         * We attach on every ancor tag a onclick function
         * @param s Handle of html control
         * @param e event arguments
         */
        static OnInit(s: BAClientHtmlEditor, e: ASPxClientEventArgs): void;
        static GotFocus(s: BAClientHtmlEditor, e: any): void;
        static LostFocus(s: BAClientHtmlEditor, e: any): void;
        static OnPopUpInit(s: BAClientPopupControl, e: ASPxClientEventArgs): void;
        static OnChanged(s: BAClientHtmlEditor, e: ASPxClientEventArgs): void;
        /**
         * Commands of the context menu and toolbox (no custom tools) in html editor
         */
        static OnCommandExecuting: (s: any, e: any) => void;
        static OnCommandExecuted: (s: BAClientHtmlEditor, e: any) => void;
        /**
         * On custom command. It must be handled
         */
        static OnCustomCommand: (s: BAClientHtmlEditor, e: any) => void;
        static OnDialogInitialized(s: any, e: any): void;
        static OnDialogClosed(s: any, e: any): void;
        static OnHTMLChange(sender: ASPxClientControl, evt: ASPxClientProcessingModeEventArgs): void;
        static SaveState(ctrl: any, state: any): void;
        static RestoreState(ctrl: any, state: any): void;
        static SaveStateMemo(ctrl: any, state: any): void;
        static RestoreStateMemo(ctrl: any, state: any): void;
        /**
         * Reset the height of the html control to either the configured value or fullscreen
         * @param elementName   The name of the HTMLControl element
         * @param delayed       TRUE if we need to delay the reset of the height
         */
        private static ResetHeight;
    }
}
