declare module BA.Ui.Widgets {
    /** Class for RecentlyUsed Widget */
    class RecentlyUsedWidget extends Widget {
        /**
         * Initializes the recently used widget.
         */
        Init(): void;
        Unload(): void;
        /**
         * Attach the events needed for the drag and drop interaction of google maps widgets.
         */
        AttachDragAndDropEvents(): void;
        OnContentLoaded(): void;
        /**
         * Open item from View
         * @param s
         * @param e
         */
        static OpenItemFromView(s: ASPxClientControlBase, e: any): void;
        /**
         * Open Recently Used item
         * @param formId Id of the form
         * @param oid OID of item
         * @param openInDialog Open form in Dialog?
         * @param fromView Open from View?
         */
        static OpenItem(formId: string, oid: string, openInDialog: string, fromView?: boolean): void;
        /**
         * Show or hide Show More button in Recently Used Widget on Resize
         * @param widget The Recently Used Widget
         */
        private ShowHideShowMore;
    }
}
